; For JFW 11.X and later (old JAWS versions might support this scripts, but that's not guaranteed)
; Scripts for OnToys - Online card and logical games.
; Program written by Ivan Sebekin (Copyright 2011 SinSoft)
; Scripts written by Denis Shishkin aka Outsider (Copyright 2011 - 2013)
; Contact SinSoft: admin@ontoys.net
; Contact me: outsidepro@rambler.ru
; For SinSoft specially!
; Enjoy! =)


Include "hjconst.jsh"
Include "Ontoys.jsh"
Include "Ontoys.jsm"

Void Function AutoStartEvent ()
AutoStartEvent ()
DetectOnToysCurrentLang ()
EndFunction

; The following function written by Ivan Sebekin and modified by me. I think you must know original copyrights, because i don't like assign not my code to myself! =)
Bool Function isOnToysClass()
Return (GetWindowClass (GetFocus()) == "Window") && (isPCCursor() && not UserBufferIsActive ())
EndFunction


bool Function SmilesWindowIsActive ()
Return InHJDialog () && GetWindowName (GetForeGroundWindow ())==GetMSG ("SelectSmile_Caption")
EndFunction

Void Function FocusChangedEvent (Handle hWindow, Handle PrevWindow)
FocusChangedEvent (hWindow, PrevWindow)
If GetWindowClass (GetCurrentWindow ())=="Edit" && GetWindowSubtypeCode (GetFocus (), 0)==66 && GetCurrentWindow ()!=hLastFocused then
SayMessage (OT_HELP, GetMSG ("PasteSmileKey_msg"))
EndIf
If not InHJDialog () then
Let hLastFocused = hWindow
EndIf
EndFunction


Int Function KeySendProcess ()
if isOnToysClass() Then
TypeCurrentScriptKey ()
Return TRUE
else
Return FALSE
EndIf
EndFunction


Void Function PlaySoundEx (string Filename)
Var
Int Conf,
string UniquePath
Let Conf = IniReadInteger ("ScriptOptions", "SoundsEx", 0, GetActiveConfiguration ()+".jcf")
If Conf then
Let UniquePath = GetJAWSSettingsDirectory ()+"OntoysSounds\\"+Filename+".wav"
PlaySound (UniquePath)
EndIf
EndFunction

Script ScriptFileName ()
ScriptAndAppNames (FormatString (GetMSG ("OntoysScripts_title"), GetMsg ("LangName_title"), GetMsg ("TranslatedBy_title")))
EndScript

Script SayPriorLine ()
if not KeySendProcess () then
PerformScript SayPriorLine()
EndIf
EndScript

Script SayPriorCharacter ()
if not KeySendProcess () then
PerformScript SayPriorCharacter()
EndIf
EndScript

Script SayNextCharacter ()
if not KeySendProcess () then
PerformScript SayNextCharacter()
EndIf
EndScript

Script SayNextLine ()
if not KeySendProcess () then
PerformScript SayNextLine()
EndIf
EndScript

Script SelectPriorLine ()
if not KeySendProcess () then
PerformScript SelectPriorLine()
EndIf
EndScript

Script SelectNextLine ()
if not KeySendProcess () then
PerformScript SelectNextLine()
EndIf
EndScript

Script SelectPriorCharacter ()
if not KeySendProcess () then
PerformScript SelectPriorCharacter()
EndIf
EndScript

Script SelectNextCharacter ()
if not KeySendProcess () then
PerformScript SelectNextCharacter()
EndIf
EndScript

Script SayPriorWord ()
if not KeySendProcess () then
PerformScript SayPriorWord()
EndIf
EndScript

Script SayNextWord ()
if not KeySendProcess () then
PerformScript SayNextWord()
EndIf
EndScript

Script ControlUpArrow ()
if not KeySendProcess () then
PerformScript ControlUpArrow ()
EndIf
EndScript

Script ControlDownArrow ()
if not KeySendProcess () then
PerformScript ControlDownArrow ()
EndIf
EndScript

Script CloseListBox ()
TypeCurrentScriptKey ()
EndScript

Script OpenListBox ()
{Alt+DownArrow
EndScript

Script JAWSHome ()
if not KeySendProcess () then
PerformScript JAWSHome ()
EndIf
EndScript

Script JAWSEnd ()
if not KeySendProcess () then
PerformScript JAWSEnd ()
EndIf
EndScript

Script JAWSPageUp ()
if not KeySendProcess () then
PerformScript JAWSPageUp ()
EndIf
EndScript


Script JAWSPageDown ()
if not KeySendProcess () then
PerformScript JAWSPageDown ()
EndIf
EndScript




Script JAWSDelete ()
If SmilesWindowIsActive () && GetWindowClass (GetCurrentWindow ())=="SysListView32" then
SendMessage (FindWindowWithClassAndId (GetForeGroundWindow (), "Button", 7173), WM_LBUTTONDOWN, 1, 1)
SendMessage (FindWindowWithClassAndId (GetForeGroundWindow (), "Button", 7173), WM_LBUTTONUP, 1, 1)
Return
EndIf
if not KeySendProcess () then
PerformScript JAWSDelete ()
EndIf
EndScript

Script SayWindowPromptAndText ()
If isOnToysClass () then
SendMessage (GetFocus (), SND_tClassSayTable, 0, 0)
Return
EndIf
PerformScript SayWindowPromptAndText ()
EndScript

Void Function DetectOnToysCurrentLang ()
Var
Int i,
String OntoysINIPath,
String tmp,
String Locale
Let tmp = GetJAWSSettingsDirectory ()
Let i = StringLength (StringSegment (StringReverse (tmp), "\\", 1))+StringLength (StringSegment (StringReverse (tmp), "\\", 2))+StringLength (StringSegment (StringReverse (tmp), "\\", 3))+StringLength (StringSegment (StringReverse (tmp), "\\", 4))+StringLength (StringSegment (StringReverse (tmp), "\\", 5))+5
Let i = StringLength (tmp)-i
Let tmp = StringLeft (tmp, i)
Let OntoysINIPath = tmp+"\\OnToys\\OnToys"+OntoysConfigFileExtention
Let Locale = IniReadString ("Main", "Language", "English", OntoysINIPath)
If not StringCompare (Locale, gCurrentLang) || StringContains (msg_Strings, "Unknown message ID") then
ClearMessagesMemory ()
EndIf
Let gCurrentLang = Locale
EndFunction

String Function GetOnToysCurrentLang ()
If not gCurrentLang then
DetectOnToysCurrentLang ()
EndIf
Return gCurrentLang
EndFunction

Int Function GetMSGId (string str_ID)
Var
Int i,
Int StringsCounter,
Int RealID
Let RealID = 0
Let StringsCounter = StringSegmentCount (msg_IDs, "|")
Let i = 1
While (i<StringsCounter)
If StringSegment (msg_IDs, "|", i)==str_ID then
Let RealID = i
; Break the While process
Let i = StringsCounter
EndIf
Let i = i+1
EndWhile
Return RealID
EndFunction

String Function GetMessageStringByID (int iID)
Return StringSegment (msg_Strings, "|", iID)
EndFunction

String Function LoadMessageFromLocale (string Message_ID, string Locale)
Var
String CurMessage
Let CurMessage = IniReadString ("Strings_"+Locale, Message_ID, "Unknown message ID: "+Message_ID, FormatString (MSGFileName, Locale))
If not StringIsBlank (msg_IDs) then
Let msg_IDs = msg_IDs+"|"
EndIf
Let msg_IDs = msg_IDs+Message_ID
If not StringIsBlank (msg_Strings) then
Let msg_Strings = msg_Strings+"|"
EndIf
Let msg_Strings = msg_Strings+CurMessage
Return CurMessage
EndFunction

Void Function ClearMessagesMemory ()
Let msg_IDs = ""
Let msg_Strings = ""
EndFunction

String Function GetMSG (string MsgID)
Var
Int ID,
String ReturnMessage
Let ID = GetMSGId (MsgID)
If id==0 then
Let ReturnMessage = LoadMessageFromLocale (MsgID, GetOnToysCurrentLang ())
;SayString ("From file")
Else
Let ReturnMessage = GetMessageStringByID (id)
;SayString ("from memory")
EndIf
Return ReturnMessage
EndFunction

Function AddSmileToBase (string SmileLocale)
Var
String sName,
String sValue
If InputBox (GetMSG ("AddSmile1_static"), GetMSG ("AddSmile_Caption"), sName)==0 then
Return
EndIf
If InputBox (GetMSG ("AddSmile2_static"), GetMSG ("AddSmile_Caption"), sValue)==0 then
Return
EndIf
If sName && sValue then
If IniReadString ("DBItems"+SmileLocale, sName, "null", FormatString (SmilesDBFileName, SmileLocale))=="null" then
IniWriteString ("DBItems"+SmileLocale, sName, sValue, FormatString (SmilesDBFileName, SmileLocale))
SayMessage (OT_USER_REQUESTED_INFORMATION, FormatString (GetMSG ("SmileHasBeenAdded_msg"), sName))
Else
ExMessageBox (FormatString (GetMSG ("AddSmileError1_STATIC"), sName), GetMSG ("AddSmileError_Caption"), MB_OK|MB_ICONERROR)
EndIf
Else
ExMessageBox (FormatString (GetMSG ("AddSmileError2_STATIC"), sName), GetMSG ("AddSmileError_Caption"), MB_OK|MB_ICONERROR)

EndIf
ScheduleFunction ("RecallPasteASmile", 1)
EndFunction

Void Function EditSmile (string Locale, string strName)
Var
String sName,
String sValue
Let sName = strName
Let sValue = IniReadString ("DBItems"+Locale, strName, "NULL", FormatString (SmilesDBFileName, Locale))
SayMessage (OT_MESSAGE, FormatString (GetMSG ("YouEditTheSmile_msg"), sName))
SpellString (sValue)
If InputBox (GetMSG ("AddSmile1_static"), GetMSG ("EditSmile_Caption"), sName)==0 then
Return
EndIf
If InputBox (GetMSG ("AddSmile2_static"), GetMSG ("EditSmile_Caption"), sValue)==0 then
Return
EndIf
If sName && sValue then
If StringCompare (strName, sName) then
IniRemoveKey ("DBItems"+Locale, strName, FormatString (SmilesDBFileName, Locale))
Pause ()
EndIf
IniWriteString ("DBItems"+Locale, sName, sValue, FormatString (SmilesDBFileName, Locale))
SayMessage (OT_USER_REQUESTED_INFORMATION, FormatString (GetMSG ("SmileHasBeenEdited_msg"), sName))
Else
ExMessageBox (FormatString (GetMSG ("AddSmileError2_STATIC"), sName), GetMSG ("EditSmileError_Caption"), MB_OK|MB_ICONERROR)

EndIf
ScheduleFunction ("RecallPasteASmile", 1)
EndFunction

Function RecallPasteASmile ()
PerformScript PasteASmile ()
EndFunction

String Function GetSortBTN ()
Var
Int SortState
Let SortState = IniReadInteger ("ScriptOptions", "Sort", 0, GetActiveConfiguration ()+".jcf")
If SortState==0 then
Return GetMSG ("EnableSorting_btn")
ElIf SortState==1 then
Return GetMSG ("DisableSorting_btn")
EndIf
EndFunction

Script PasteASmile ()
Var
Int sChoice,
Int sAction,
Int SortState,
String sNames,
String SelectedSmile,
String OntoysINIPath,
String OntoysCurrentLang
If MenusActive () then
TypeCurrentScriptKey ()
Return
EndIf
If GetWindowClass (GetCurrentWindow ())=="Edit" && GetWindowSubtypeCode (GetCurrentWindow (), 0)==66 then
Let OntoysINIPath = StringSegment (GetAPPFilePath (), ".", 1)+OntoysConfigFileExtention
Let OntoysCurrentLang = GetOnToysCurrentLang ()
If StringIsBlank (IniReadSectionNames (FormatString (SmilesDBFileName, OntoysCurrentLang))) then
ExMessageBox (GetMSG ("SmilePasteError4_static"), GetMSG ("SmilePasteErrorFile_Caption"), MB_OK|MB_ICONERROR)
EndIf
Let sNames = IniReadSectionKeys ("DBItems"+OntoysCurrentLang, FormatString (SmilesDBFileName, OntoysCurrentLang))
If IniReadSectionNames (FormatString (SmilesDBFileName, OntoysCurrentLang)) && StringIsBlank (IniReadSectionKeys ("DBItems"+OntoysCurrentLang, FormatString (SmilesDBFileName, OntoysCurrentLang))) then
ExMessageBox (GetMSG ("SmilePasteError5_static"), GetMSG ("SmilePasteErrorFile_Caption"), MB_OK|MB_ICONERROR)
EndIf
Let SortState = IniReadInteger ("ScriptOptions", "Sort", 0, GetActiveConfiguration ()+".jcf")
; If your JAWS version is older as 11, you must make the following one line as comment by semicolon symbol. Type semicolon symbol on the top of the line, then uncomment alternative code for successfull scripts compilation. Delete semicolon symbol on two alternative code lines, which assigned as alternative code by comments above.
;    JAWS  11,             .             ,        ,     ,    .
Let sChoice = DlgSelectItemInList (sNames, GetMSG ("SelectSmile_Caption"), SortState, PrevSelected, GetMSG ("AddSmile_btn")+"|"+GetMSG ("EditSmile_btn")+"|"+GetMSG ("DeleteSmile_btn")+"|"+GetSortBTN (), sAction)
; Two alternative code lines here:
;     :
;Let sChoice = DlgSelectItemInList (sNames, GetMSG ("SelectSmile_Caption"), SortState, PrevSelected)
;Let sAction = 0
If sAction==-1 || sAction==0 then
If sChoice && sChoice<=StringSegmentCount (sNames, "|") then
If GetWindowClass (GetCurrentWindow ())=="Edit" && GetWindowSubtypeCode (GetFocus (), 0)==66 then
Let SelectedSmile = IniReadString ("DBItems"+OntoysCurrentLang, StringSegment (sNames, "|", sChoice), "NULL", FormatString (SmilesDBFileName, OntoysCurrentLang))
If SelectedSmile!="NULL" then
TypeString (" "+SelectedSmile+" ")
SayMessage (OT_MESSAGE, FormatString (GetMSG ("SmilePasted_msg"), StringSegment (sNames, "|", sChoice)))
Else
ExMessageBox (GetMSG ("SmilePasteError1_static"), GetMSG ("SmilePasteError_Caption"), MB_OK|MB_ICONERROR)
EndIf
Else
ExMessageBox (GetMSG ("SmilePasteError2_static"), GetMSG ("SmilePasteError_Caption"), MB_OK|MB_ICONERROR)
EndIf
Let PrevSelected = sChoice
EndIf
ElIf sAction==1 then
AddSmileToBase (OntoysCurrentLang)
ElIf sAction==2 then
If sChoice then
EditSmile (OntoysCurrentLang, StringSegment (sNames, "|", sChoice))
Let PrevSelected = sChoice
Else
ExMessageBox (GetMSG ("NothingToEdit_Static"), GetMSG ("EditSmile_Caption"), MB_OK|MB_ICONERROR)
Let PrevSelected = sChoice
ScheduleFunction ("RecallPasteASmile", 1)
EndIf
ElIf sAction==3 then
If StringIsBlank (sNames) then
ExMessageBox (GetMSG ("DeleteSmileError1_static"), GetMSG ("DeleteSmile_caption"), MB_OK|MB_ICONERROR)
Return
EndIf
If sChoice then
Let sAction = ExMessageBox (FormatString (GetMSG ("DeleteSmile_qst"), Stringsegment (sNames, "|", sChoice)), GetMSG ("DeleteSmile_caption"), MB_YESNO|MB_ICONQUESTION)
Let PrevSelected = sChoice
If sAction==6 then
IniRemoveKey ("DBItems"+OntoysCurrentLang, StringSegment (sNames, "|", sChoice), FormatString (SmilesDBFileName, OntoysCurrentLang))
SayMessage (OT_USER_REQUESTED_INFORMATION, FormatString (GetMSG ("SmileHasBeenDeleted_msg"), StringSegment (sNames, "|", sChoice)))
Let PrevSelected = 0
EndIf
ScheduleFunction ("RecallPasteASmile", 1)
Else
ExMessageBox (GetMSG ("DeleteSmileError2_static"), GetMSG ("DeleteSmile_caption"), MB_OK|MB_ICONERROR)
ScheduleFunction ("RecallPasteASmile", 1)
EndIf
ElIf sAction==4 then
Let SortState = IniReadInteger ("ScriptOptions", "Sort", 0, GetActiveConfiguration ()+".jcf")
If SortState==0 then
IniWriteInteger ("ScriptOptions", "Sort", 1, GetActiveConfiguration ()+".jcf")
SayMessage (OT_USER_REQUESTED_INFORMATION, GetMSG ("SortingIsEnabled_msg"))
ElIf SortState==1 then
IniWriteInteger ("ScriptOptions", "Sort", 0, GetActiveConfiguration ()+".jcf")
SayMessage (OT_USER_REQUESTED_INFORMATION, GetMSG ("SortingIsDisabled_msg"))
EndIf
Let PrevSelected = sChoice
ScheduleFunction ("RecallPasteASmile", 1)
EndIf
Else
;ExMessageBox (GetMSG ("SmilePasteError6_static"), GetMSG ("SelectSmile_Caption"), MB_OK|MB_ICONERROR)
Beep ()
Say (GetMSG ("SmilePasteError_Caption")+": "+GetMSG ("SmilePasteError6_static"), OT_ERROR)
EndIf
EndScript


